//******************************************************************************
// "RADIOSITY LIGHTMAPS 8" by Georgy Moshkin
// -----------------------------------------------
// email  : tmtlib@narod.ru
// WWW    : http://www.tmtlib.narod.ru/
//
// Version: 0.3
// Example: 8
//
// Notes:
// -------
// Blur routine by Jean Yves Quinec - j.y.q@wanadoo.fr
//
// License:
// --------
// This unit is freely distributable without licensing fees and is
// provided without guarantee or warrantee expressed or implied. This unit
// is Public Domain. Feel free to use or enhance this code. You can use the
// program for any purpose you see fit.
//
//******************************************************************************

unit rad8;

interface

uses Windows,OpenGL,_vector,dialogs,sysutils,math;

const leveldim=16; //   

type TPixel = Record    // 
       R, G, B : Byte;
     end;

type Tixel = Record         //  ""    
       R, G, B,I : Integer;
     end;

type TBMP=object                // 
           Texture : Pointer;   //   
           TextureGL : glUint;  // OpenGL-  
           width,height:integer; //   
           procedure MakeTexture(w,h:integer;filter:glint); //    w x h
                                                            // filter - OpenGL- 

           procedure MakeIndex(poly:byte); //    " "

           procedure Fill(r,g,b:byte);  //    rgb

           procedure FillRect(x1,x2,y1,y2:integer;r,g,b:byte); //      rgb

           procedure UpdateTexture(filter:glint); //  OpenGL- 

           procedure SetPixel(x,y:integer;r,g,b:byte); //  

           procedure AddPixel(x,y:integer;r,g,b:byte); //     x,y  r,g,b

           function GetPixel(x,y:integer):TPixel; //  

           procedure GetPixelB(x,y:integer;var r,g,b:byte); //   ( ,   GetPixel,
                                                            //    )

           //     
           //    :

           procedure Clamp;      // /      

           procedure Blur(radius:single); //  

           procedure Stir; //    (   )

          end;


//   ,    TBMP,   INTEGER    I
// R,G,B -  () I -  
type TIMP=object
           Texture : array[0..512,0..512] of TIxel;
           width,height:integer;
           procedure MakeTexture(w,h:integer);
           procedure Fill(r,g,b:integer);
           procedure FillRect(x1,x2,y1,y2:integer;r,g,b:integer);
           procedure SetPixel(x,y:integer;r,g,b:integer);
           procedure AddPixel(x,y:integer;r,g,b:integer);
           function GetPixel(x,y:integer):TIxel;
          end;

var        lmap:array[0..leveldim-1] of TBMP; // 
           tmap:array[0..leveldim-1] of TBMP; // 
           imap:array[0..leveldim-1] of TBMP; // 
           //   

           maxImp:TIxel; //   (  )

           iterate:integer=0; //  

          //     
         fixA,fixB,fixC,fixAA,fixBB,fixCC: single;
         fixM:integer;

         //   :
         lol,fix:integer;

         // boolean-    
         rpx:boolean=true;


type TQuad=record               //   
           p1,p2,p3,p4:TVector; //  
           normal:TVector;      // 
           end;

// 3d  :           
var level:array[0..leveldim-1] of TQUAD;     // 11 


// OpenGL- 
procedure glBindTexture(target: GLenum; texture: GLuint); stdcall; external opengl32;
procedure glGenTextures(n: GLsizei; var textures: GLuint); stdcall; external opengl32;
procedure glDeleteTextures (n: GLsizei; textures: PGLuint); stdcall; external opengl32;


procedure MakeRoom;
procedure RenderQuad(mde:integer); //  

const sze=256; // .  
var rptrP:pointer; //       ""
    rptrN:pointer; //   ""

    //  
    //    rptrT:pointer;

    //    z-buffera     
    zbufP:packed array[0..sze-1,0..sze-1] of glFloat;
    zbufN:packed array[0..sze-1,0..sze-1] of glFloat;

    //  
    rw:integer;
    rh:integer;

//     Radiosity
// rptrP, rptrN, zbufP, zbufN
procedure RPTRmake(w,h:integer); // w h -  

procedure DistributeLight; //   (  )

// ""  (   )
function IxelNorm(zinp:Tixel):TPixel;

implementation

//   -    
function adj(inp:single):single;
var z:single;
begin
z:=inp;
if (z>0.4) and (z<0.5) then
z:=sin(z*3.14/0.5);
result:=z;
end;


//   
function IxelNorm(zinp:Tixel):TPixel;
var sr,sg,sb:single;
begin
(*
sr:={adj}(zinp.r/maxImp.r)*255;
sg:={adj}(zinp.g/maxImp.g)*255;
sb:={adj}(zinp.b/maxImp.b)*255;


sr:=zinp.r;
sg:=zinp.g;
sb:=zinp.b;

if sr>255 then sr:=255;//-5*sin(1.67*zinp.g/maxImp.g);
if sg>255 then sg:=255;//-5*sin(1.67*zinp.g/maxImp.r);
if sb>255 then sb:=255;



result.R:=round(sr);
result.G:=round(sg);
result.B:=round(sb);
*)
end;


//  : , , ,..
procedure RenderQuad(mde:integer); //  

var i:integer; //  

const updown=1;

begin
  glDepthFunc(GL_LEQUAL);              // The Type Of Depth Testing (Less Or Equal)
  glEnable(GL_DEPTH_TEST);             // Enable Depth Testing
  glEnable(GL_TEXTURE_2D);
  glEnable(GL_CULL_FACE);

  glColor4f(1,1,1,1);
  glDisable(GL_BLEND);



if mde=0 then
 begin

 for i:=0 to leveldim-1 do //    
 with level[i] do
  begin
  glBindTexture(GL_TEXTURE_2D, tmap[i].TextureGL);

   glBegin(GL_QUADS);

   glTexCoord2f(0,0);           //  
   glVertex3f(p1.x,p1.y,p1.z);  //  

   glTexCoord2f(1,0);
   glVertex3f(p2.x,p2.y,p2.z);

   glTexCoord2f(1,1);
   glVertex3f(p3.x,p3.y,p3.z);

   glTexCoord2f(0,1);
   glVertex3f(p4.x,p4.y,p4.z);

   glEnd;
  end;

end;


if mde=3 then
 begin
 glFrontFace(GL_CW);
glDisable(GL_TEXTURE_2D);
glColor3f(1,1,1);
 for i:=0 to leveldim-1 do //    
 with level[i] do
  begin

   glBegin(GL_QUADS);

   glTexCoord2f(0,0);           //  
   glVertex3f(p1.x,p1.y,p1.z);  //  

   glTexCoord2f(1,0);
   glVertex3f(p2.x,p2.y,p2.z);

   glTexCoord2f(1,1);
   glVertex3f(p3.x,p3.y,p3.z);

   glTexCoord2f(0,1);
   glVertex3f(p4.x,p4.y,p4.z);

   glEnd;
  end;
  glEnable(GL_TEXTURE_2D);

 glFrontFace(GL_CCW);
 glColor3f(1,1,1);



end;




if mde=2 then
 begin

 for i:=0 to leveldim-1 do //    
 with level[i] do
  begin
  glBindTexture(GL_TEXTURE_2D, imap[i].TextureGL);

   glBegin(GL_QUADS);

   glTexCoord2f(0,0);           //  
   glVertex3f(p1.x,p1.y,p1.z);  //  

   glTexCoord2f(1,0);
   glVertex3f(p2.x,p2.y,p2.z);

   glTexCoord2f(1,1);
   glVertex3f(p3.x,p3.y,p3.z);

   glTexCoord2f(0,1);
   glVertex3f(p4.x,p4.y,p4.z);

   glEnd;
  end;

end;

if mde=1 then
begin

    glBlendFunc(GL_ZERO, GL_SRC_COLOR);
    glEnable(GL_BLEND);
    glcolor4f(1,1,1,1);

 for i:=0 to leveldim-1 do //    
 with level[i] do
  begin
  glBindTexture(GL_TEXTURE_2D, lmap[i].TextureGL);

   glBegin(GL_QUADS);

   glTexCoord2f(0,0);           //  
   glVertex3f(p1.x,p1.y,p1.z);  //  

   glTexCoord2f(1,0);
   glVertex3f(p2.x,p2.y,p2.z);

   glTexCoord2f(1,1);
   glVertex3f(p3.x,p3.y,p3.z);

   glTexCoord2f(0,1);
   glVertex3f(p4.x,p4.y,p4.z);

   glEnd;
  end;

glDisable(GL_BLEND);

end;



end;


//      LIGHTMAP-
//     
var Uvector,Vvector:TVector;
var      su,sv:integer;

const dp=0.6; //      


procedure MakeRoom;
var big:array[1..8] of TVector;
var average:array[1..8] of TVector;
var small:array[1..8] of TVector;
        i,ffp:integer;



begin

big[1]:=makethis(-20, -20, 20);
big[2]:=makethis(20, -20 ,20);
big[3]:=makethis(20, -20,-20);
big[4]:=makethis(-20, -20, -20);

big[5]:=makethis(-20, 20, 20);
big[6]:=makethis(20,  20 ,20);
big[7]:=makethis(20,  20,-20);
big[8]:=makethis(-20, 20, -20);

average[1]:=makethis(-8.75, -20 ,1.75);
average[2]:=makethis(1,     -20, -3);
average[3]:=makethis(-4.25, -20, -14.25);
average[4]:=makethis(-14.25,-20,-9.75);

average[5]:=makethis(-8.75, 2.75 ,1.75);
average[6]:=makethis(1,     2.75, -3);
average[7]:=makethis(-4.25, 2.75, -14.25);
average[8]:=makethis(-14.25,2.75,-9.75);

small[1]:=makethis(2,    -20, 8.75);
small[2]:=makethis(13,   -20, 11.25);
small[3]:=makethis(15.5, -20, 1);
small[4]:=makethis(5,    -20, -1.5);

small[5]:=makethis(2,    -7, 8.75);
small[6]:=makethis(13,   -7, 11.25);
small[7]:=makethis(15.5, -7, 1);
small[8]:=makethis(5,    -7, -1.5);




with level[0] do
 begin
  p1:=big[1];
  p2:=big[2];
  p3:=big[3];
  p4:=big[4];
  normal:=NormalVector(p1,p2,p3);
 end;

with level[1] do
 begin
  p1:=big[5];
  p2:=big[8];
  p3:=big[7];
  p4:=big[6];
  normal:=NormalVector(p1,p2,p3);
 end;

with level[2] do
 begin
  p1:=big[1];
  p2:=big[4];
  p3:=big[8];
  p4:=big[5];
  normal:=NormalVector(p1,p2,p3);
 end;

with level[3] do
 begin
  p1:=big[3];
  p2:=big[2];
  p3:=big[6];
  p4:=big[7];
  normal:=NormalVector(p1,p2,p3);
 end;

with level[4] do
 begin
  p1:=big[1];
  p2:=big[5];
  p3:=big[6];
  p4:=big[2];
  normal:=NormalVector(p1,p2,p3);
 end;

with level[5] do
 begin
  p1:=big[4];
  p2:=big[3];
  p3:=big[7];
  p4:=big[8];
  normal:=NormalVector(p1,p2,p3);
 end;

// average

with level[6] do
 begin
  p1:=average[5];
  p2:=average[6];
  p3:=average[7];
  p4:=average[8];
  normal:=NormalVector(p1,p2,p3);
 end;

with level[7] do
 begin
  p1:=average[1];
  p2:=average[5];
  p3:=average[8];
  p4:=average[4];
  normal:=NormalVector(p1,p2,p3);
 end;

with level[8] do
 begin
  p1:=average[3];
  p2:=average[7];
  p3:=average[6];
  p4:=average[2];
  normal:=NormalVector(p1,p2,p3);
 end;

with level[9] do
 begin
  p1:=average[1];
  p2:=average[2];
  p3:=average[6];
  p4:=average[5];
  normal:=NormalVector(p1,p2,p3);
 end;

with level[10] do
 begin
  p1:=average[4];
  p2:=average[8];
  p3:=average[7];
  p4:=average[3];
  normal:=NormalVector(p1,p2,p3);
 end;

// small

with level[11] do
 begin
  p1:=small[5];
  p2:=small[6];
  p3:=small[7];
  p4:=small[8];
  normal:=NormalVector(p1,p2,p3);
 end;

with level[12] do
 begin
  p1:=small[1];
  p2:=small[5];
  p3:=small[8];
  p4:=small[4];
  normal:=NormalVector(p1,p2,p3);
 end;

with level[13] do
 begin
  p1:=small[3];
  p2:=small[7];
  p3:=small[6];
  p4:=small[2];
  normal:=NormalVector(p1,p2,p3);
 end;

with level[14] do
 begin
  p1:=small[1];
  p2:=small[2];
  p3:=small[6];
  p4:=small[5];
  normal:=NormalVector(p1,p2,p3);
 end;

with level[15] do
 begin
  p1:=small[4];
  p2:=small[8];
  p3:=small[7];
  p4:=small[3];
  normal:=NormalVector(p1,p2,p3);
 end;


for i:=0 to leveldim-1 do
begin


with level[i] do
UVector:=VecMinusVec(p2,p1);

with level[i] do
VVector:=VecMinusVec(p4,p1);

//     

su:=round(VectorLen(UVector)/dp);
sv:=round(VectorLen(VVector)/dp);

//   

if su<2 then su:=2;  //   ,  2 x 2
if sv<2 then sv:=2;
ffp:=2;

//     :
//   
// 2x2 , 4x2, 8x2, ... 256x2  ..  

while ffp<su do
begin
ffp:=ffp*2;
end;
su:=ffp;

ffp:=2;

//   :

while ffp<sv do
begin
ffp:=ffp*2;
end;
sv:=ffp;


//  
lmap[i].MakeTexture(su,sv,GL_LINEAR);
tmap[i].MakeTexture(su,sv,GL_LINEAR);
// :
imap[i].MakeTexture(su,sv,GL_NEAREST); //    !!!!
//    ( )

//     
tmap[i].Fill(255,255,255);

//   
imap[i].MakeIndex(i);

//  OpenGL- 
tmap[i].UpdateTexture(GL_LINEAR);
lmap[i].UpdateTexture(GL_LINEAR);
imap[i].UpdateTexture(GL_NEAREST); //   GL_NEAREST -  
end;

//  
tmap[2].Fill(150,255,150);

//  
tmap[3].Fill(255,150,150);

// :
tmap[2].UpdateTexture(GL_LINEAR);
tmap[3].UpdateTexture(GL_LINEAR);




end;

//        bilinear-:
const GL_CLAMP_TO_EDGE                                   = $812F;

function CreateTexture(Width, Height : Integer; pData : Pointer; filter:glint) : glUint;
var Texture : glUint;
begin
  glGenTextures(1, Texture);
  glBindTexture(GL_TEXTURE_2D, Texture);
  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);  {Texture blends with object background}
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, filter); { only first two can be used }
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, filter); { all of the above can be used }

//        bilinear-:
  glTexParameteri(GL_TEXTURE_2D,  GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
  glTexParameteri(GL_TEXTURE_2D,  GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);

  glTexImage2D(GL_TEXTURE_2D, 0, 3, Width, Height, 0, GL_RGB, GL_UNSIGNED_BYTE, pData);

  result :=Texture;
end;


procedure TBMP.MakeTexture(w,h:integer;filter:glint);
begin
  width:=w;
  height:=h;

  GetMem(Texture, w*h*3);
  FillChar(Texture^, w*h*3, 0); 
  TextureGL :=CreateTexture(w,h, Texture,filter);
end;

//   
procedure TBMP.MakeIndex(poly:byte);
var i,j:byte;
begin

 for i:=0 to width-1 do
  for j:=0 to height-1 do
   begin
    SetPixel(i,j,poly,i,j) //  R,G,B   :
                           // R = poly  
                           // G = U   LightMap-
                           // B = V   LightMap-
   end;

end;

procedure TBMP.Fill(r,g,b:byte);
var i,j:byte;
begin

 for i:=0 to width-1 do
  for j:=0 to height-1 do
   begin
    SetPixel(i,j,r,g,b)
   end;

end;

procedure TBMP.FillRect(x1,x2,y1,y2:integer;r,g,b:byte);
var i,j:byte;
begin

 for i:=x1 to x1+x2 do
  for j:=y1 to y1+y2 do
   begin
    SetPixel(i,j,r,g,b)
   end;


end;

procedure TBMP.UpdateTexture(filter:glint);
begin
 glDeleteTextures(1, @TextureGL);
 TextureGL :=CreateTexture(width,height, Texture,filter);
end;

procedure TBMP.SetPixel(x,y:integer;r,g,b:byte);
var Pixel : ^TPixel;
begin
   Pixel :=Pointer(Integer(Texture) + 3*(x + y*width));
   Pixel^.R:=r;
   Pixel^.G:=g;
   Pixel^.B:=b;
end;

procedure TBMP.AddPixel(x,y:integer;r,g,b:byte);
var Pixel : ^TPixel;
rr,gg,bb:single;
begin
   Pixel :=Pointer(Integer(Texture) + 3*(x + y*width));
   rr:=Pixel^.R+r;
   gg:=Pixel^.G+g;
   bb:=Pixel^.B+b;
//   if rr>70 then rr:=rr*1.3;
//   if gg>70 then gg:=gg*1.3;
//   if bb>70 then bb:=bb*1.3;
   if rr>255 then rr:=255;
   if gg>255 then gg:=255;
   if bb>255 then bb:=255;
   Pixel^.R:=round(rr);
   Pixel^.G:=round(gg);
   Pixel^.B:=round(bb);
end;

procedure TBMP.Clamp;
var Pixel : ^TPixel;
var rr,gg,bb:single;
i,j:integer;
begin
for i:=0 to width-1 do
 for j:=0 to height-1 do
  begin
   Pixel :=Pointer(Integer(Texture) + 3*(i + j*width));
   rr:=Pixel^.R * 0.1;
   gg:=Pixel^.G * 0.1;
   bb:=Pixel^.B * 0.1;
   Pixel^.R:=round(rr);
   Pixel^.G:=round(gg);
   Pixel^.B:=round(bb);
 end;
end;

procedure TBMP.Stir;
var i,j,k,l:integer;
var rr,gg,bb,rrr,ggg,bbb:byte;
xx,yy,zz:byte;
const sz=2;
procedure corr(var a,b:integer;c,d:integer);
begin
 if a<0 then a:=0;
 if a>c then a:=c;
 if b<0 then b:=0;
 if b>d then b:=d;
end;
begin

 for i:=0 to width-1 do
  for j:=0 to height-1 do
   begin
    k:=i+sz-(1+random(sz*2));
    l:=j+sz-(1+random(sz*2));
    corr(k,l,width-1,height-1);

    GetPixelB(i,j,rr,gg,bb);
    GetPixelB(k,l,rrr,ggg,bbb);

    (*
    rr:=round((rr+rrr)/2);
    gg:=round((gg+ggg)/2);
    bb:=round((bb+bbb)/2);
     *)
    SetPixel(k,l,rr,gg ,bb);
//    SetPixel(i,j,rr,gg ,bb);
    SetPixel(i,j,rrr,ggg,bbb);


   end;


end;


procedure TBMP.Blur(radius:single);
const ksz=5; //75
var weight:array[-ksz..ksz] of single;
var j,i:integer;
    temp:double;
var n, LocalRow: integer; tr, tg, tb: double; //tempRed, etc
    w: double;
var    sr,sg,sb:byte;
       wdt,hgt:integer;

var picbits:pointer;
    pixel:^TPixel;
function TrimInt(Lower, Upper, theInteger: integer): integer;
begin
 if (theInteger <= Upper) and (theInteger >= Lower) then
  result:= theInteger
 else
  if theInteger > Upper then
   result:= Upper
    else
     result:= Lower;
end;

function TrimReal(Lower, Upper: integer; x: double): integer;
begin
 if (x < upper) and (x >= lower) then
  result:= trunc(x)
 else
  if x > Upper then
   result:= Upper
    else
     result:= Lower;
end;



begin

 for j:=-ksz to ksz do
  begin
    temp:= j/radius;
    weight[j]:= exp(- temp*temp/2);
  end;

//     writeln(weight[j]);

  temp:= 0;
  for j:= -ksz to ksz do
     temp:= temp + weight[j];
  for j:= -ksz to ksz do
     weight[j]:= weight[j] / temp;

wdt:=width;
hgt:=Height;


  getmem(picbits,width*height*3);

//  if false then
for i:=0 to wdt-1 do
for j:= 0 to hgt-1 do
  begin
    tb:= 0;
    tg:= 0;
    tr:= 0;
    for n:= -ksz to ksz do
    begin
      w:= weight[n];

//the TrimInt keeps us from running off the edge of the row...

{      with theRow[TrimInt(0, High_theRow, j - n)] do}
      GetPixelB( TrimInt(0, wdt-1, i - n), j, sr,sg,sb);
//     GetPixel( TrimInt(0, wdt-1, i - n), j, sr,sg,sb);

      begin
        tb:= tb + w * sb;
        tg:= tg + w * sg;
        tr:= tr + w * sr;
      end;
    end;


{    with P^[j] do}
    begin
      sb:= TrimReal(0, 255, tb);
      sg:= TrimReal(0, 255, tg);
      sr:= TrimReal(0, 255, tr);

      Pixel := Pointer(Integer(picBits) + ({x}i+1)*3 + width*3*j{y} - 3);
//      Pixel := Pointer(Integer(picBits) + ({x}i+1)*4 + Width*4*j{y} - 4);

      //Pointer(Cardinal(picBits) + ({x}i+1)*4 + Width*4*j{y} - 4);


      Pixel^.r:=sr;
      Pixel^.g:=sg;
      Pixel^.b:=sb;
  //    SetPixel( j,0+i,sr,sg,sb);
    end;
  end;


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

move(picBits^,Texture^,width*height*3);

for i:=0 to wdt-1 do
for j:= 0 to hgt-1 do
  begin
    tb:= 0;
    tg:= 0;
    tr:= 0;
    for n:= -ksz to ksz do
    begin
      w:= weight[n];

//the TrimInt keeps us from running off the edge of the row...

{      with theRow[TrimInt(0, High_theRow, j - n)] do}

      GetPixelB( i,TrimInt(0, hgt-1, j - n), sr,sg,sb);

//     GetPixel( TrimInt(0, wdt-1, i - n), j, sr,sg,sb);

      begin
        tb:= tb + w * sb;
        tg:= tg + w * sg;
        tr:= tr + w * sr;
      end;
    end;


{    with P^[j] do}
    begin
      sb:= TrimReal(0, 255, tb);
      sg:= TrimReal(0, 255, tg);
      sr:= TrimReal(0, 255, tr);

//      Pixel := Pointer(Integer(picBits) + ({x}i+1)*3 + width*3*j{y} - 3);

      Pixel := Pointer(Integer(picBits) + ({x}i+1)*3 + width*3*j{y} - 3);
//      Pixel := Pointer(Integer(picBits) + ({x}j+1)*3 + height*3*i{y} - 3);

      Pixel^.r:=sr;
      Pixel^.g:=sg;
      Pixel^.b:=sb;
  //    SetPixel( j,0+i,sr,sg,sb);
    end;
  end;


move(picBits^,Texture^,width*height*3);
freemem(picBits,width*height*3);

end;

function TBMP.GetPixel(x,y:integer):TPixel;
var Pixel : ^TPixel;
begin
   Pixel :=Pointer(Integer(Texture) + 3*(x + y*width));
   result:=Pixel^;
end;

procedure TBMP.GetPixelB(x,y:integer;var r,g,b:byte);
var Pixel : ^TPixel;
begin
   Pixel :=Pointer(Integer(Texture) + 3*(x + y*width));
   r:=Pixel^.R;
   g:=Pixel^.G;
   b:=Pixel^.B;
end;

/// IXEL


procedure TIMP.MakeTexture(w,h:integer);
begin
  width:=w;
  height:=h;

//  GetMem(Texture, w*h*3*sizeOf(integer));
//  FillChar(Texture^, w*h*3*sizeOf(integer), 0);          // Fill image with dark grey
end;

procedure TIMP.Fill(r,g,b:integer);
var i,j:byte;
begin

 for i:=0 to width-1 do
  for j:=0 to height-1 do
   begin
    SetPixel(i,j,r,g,b)
   end;

end;

procedure TIMP.FillRect(x1,x2,y1,y2:integer;r,g,b:integer);
var i,j:byte;
begin

 for i:=x1 to x1+x2 do
  for j:=y1 to y1+y2 do
   begin
    SetPixel(i,j,r,g,b)
   end;


end;


procedure TIMP.SetPixel(x,y:integer;r,g,b:integer);
begin
(*
Texture[x,y].R:=byte(r);
Texture[x,y].G:=byte(g);
Texture[x,y].B:=byte(b);
*)

Texture[x,y].R:=r;
Texture[x,y].G:=g;
Texture[x,y].B:=b;

(*
   Pixel :=Pointer(Integer(Texture) + 3*(x*width + y)*sizeOf(integer));
   Pixel^.R:=r;
   Pixel^.G:=g;
   Pixel^.B:=b;
*)

end;

procedure TIMP.AddPixel(x,y:integer;r,g,b:integer);
var rr,gg,bb:single;
begin
//   Pixel :=Pointer(Integer(Texture) + 3*(x*width + y)*sizeOf(integer));
(*
   rr:=Texture[x,y].R+r/(0.05*iterate);
   gg:=Texture[x,y].G+g/(0.05*iterate);
   bb:=Texture[x,y].B+b/(0.05*iterate);
   *)

// if r>255 then r:=round(r/maxImp.R);
// if g>255 then g:=round(r/maxImp.G);
// if b>255 then b:=round(r/maxImp.B);
   rr:=Texture[x,y].R+r;
   gg:=Texture[x,y].G+g;
   bb:=Texture[x,y].B+b;


 begin
  Texture[x,y].R:=round(rr);
  Texture[x,y].G:=round(gg);
  Texture[x,y].B:=round(bb);
//  Texture[x,y].I:=Texture[x,y].I+1;
 end;

//   Pixel^.R:=round(rr);
//   Pixel^.G:=round(gg);
//   Pixel^.B:=round(bb);
end;

function TIMP.GetPixel(x,y:integer):TIxel;
//var Pixel : ^TIxel;
begin
//   Pixel :=Pointer(Integer(Texture) + 3*(x*width + y)*sizeOf(integer));

   result:=Texture[x,y];
end;


procedure RPTRmake(w,h:integer);
begin
 GetMem(rptrP, w*h*3);
 FillChar(rptrP^, w*h*3, 0);
 GetMem(rptrN, w*h*3);
 FillChar(rptrN^, w*h*3, 0);

//  
// GetMem(rptrT, w*h*3);
// FillChar(rptrT^, w*h*3, 0);

 rw:=w;
 rh:=h;
end;

procedure DistributeLight;
var i,k,l:integer;
pixelP,pixelN:^TPixel;
zx:single;

colorA,colorB:TPixel;
colorC,colorD:TPixel;

    v_eye,v_dir,v_up:Tvector;
    randvec:Tvector;
    perpvec:Tvector;
    normal:TVector;
    eye:TVector;

    angleA,angleB,angleC:single;
   rrr:single;
begin

glDisable(GL_BLEND);
 glClearColor(1,1,1, 1.0); 	   // White Background
 glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT); //  
 glLoadIdentity(); //    


  glMatrixMode(GL_PROJECTION);  // Switch to the projection matrix
  glPushMatrix();               // Save current projection matrix
  glLoadIdentity();

  glOrtho(-25, 25, -25, 25 , 0, 100); //  

  glMatrixMode(GL_MODELVIEW);  // Return to the modelview matrix
  glPushMatrix();              // Save the current modelview matrix
  glLoadIdentity();

  glPopMatrix;
  glPopMatrix;

  glViewport(0, 0, rw,rh);


  //  
     randvec.x:=1500-random(3000);
     randvec.y:=1500-random(3000);
     randvec.z:=1500-random(3000);
     randvec:=Normalize(randvec); // 


   //  
     eye.x:=(10000-random(20000))/1000;
     eye.y:=(10000-random(20000))/1000;
     eye.z:=(10000-random(20000))/1000;


   //  
     if random(10)<5 then
     eye.x:=0;
//     else
     if random(10)<5 then
     eye.y:=0;
     if random(10)<5 then
     eye.z:=0;


//   eye.x:=0;
//  eye.y:=0;
  // eye.z:=0;


     //  
     normal.x:=1500-random(3000); // ( )
     normal.y:=1500-random(3000);
     normal.z:=1500-random(3000);
     normal:=Normalize(normal); // 


     perpvec:=(CrossVector(normal,randvec)); //    ( )


     //  
 gluLookAt(eye.x,eye.y,eye.z,
           eye.x+normal.x,eye.y+normal.y,eye.z+normal.z,
           perpvec.x,perpvec.y,perpvec.z);


  //     
  renderquad(2);
  //      
  renderquad(3);

  //    zbuffer
  glReadPixels(0, 0, rw, rh, GL_RGB, GL_UNSIGNED_BYTE, rptrP);
  glReadPixels(0, 0, rw, rh, GL_DEPTH_COMPONENT, GL_FLOAT, @ZbufP);

 //  
 glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT); //  


  glLoadIdentity();

  //     ( )
 gluLookAt(eye.x,eye.y,eye.z,
           eye.x-normal.x,eye.y-normal.y,eye.z-normal.z,
           perpvec.x,perpvec.y,perpvec.z);


  //       
  //   -  
  renderquad(2);
  renderquad(3);

  //  (  rptrN  z-buffer  ZbufN
  glReadPixels(0, 0, rw, rh, GL_RGB, GL_UNSIGNED_BYTE, rptrN);
  glReadPixels(0, 0, rw, rh, GL_DEPTH_COMPONENT, GL_FLOAT, @ZbufN);

  //   
  for k:=0 to rw-1 do
   for l:=0 to rh-1 do
    begin
      PixelP:=Pointer(Integer(rptrP) + 3*(k*rw+ l));
      PixelN:=Pointer(Integer(rptrN) + 3*(k*rw + (rh-1-l)));
      if (PixelP^.R<>255) and (PixelN^.R<>255) then
       begin
        colorA:=lmap[PixelP^.R].GetPixel(PixelP^.G,PixelP^.B);
        colorB:=lmap[PixelN^.R].GetPixel(PixelN^.G,PixelN^.B);

        colorC:=tmap[PixelP^.R].GetPixel(PixelP^.G,PixelP^.B);
        colorD:=tmap[PixelN^.R].GetPixel(PixelN^.G,PixelN^.B);

       //  
       AngleA:=AngleBetweenVectors(level[PixelP^.R].normal,normal);

       AngleB:=AngleBetweenVectors(level[PixelN^.R].normal,Umnoj(normal,-1));

       AngleC:=AngleBetweenVectors(level[PixelP^.R].normal, Umnoj(level[PixelN^.R].normal,-1));

       //   
       AngleA:=cos(AngleA)*cos(AngleB);

//   
zx:=2-(zBufP[k,l]+zBufN[k,rh-1-l]);
zx:=cos((3.14/2)*zx/2);
zx:=1-zx;

//   
zx:=zx*zx;


//   
AngleA:=zx*AngleA/10;

//    
       colorA.R:=round(colorA.R*(AngleA)*colorC.R/255);
       colorA.G:=round(colorA.G*(AngleA)*colorC.G/255);
       colorA.B:=round(colorA.B*(AngleA)*colorC.B/255);

       colorB.R:=round(colorB.R*(AngleA)*colorD.R/255);
       colorB.G:=round(colorB.G*(AngleA)*colorD.G/255);
       colorB.B:=round(colorB.B*(AngleA)*colorD.B/255);

//     (    )
        with colorB do
        lmap[PixelP^.R].AddPixel(PixelP^.G,PixelP^.B,r,g,b);

        with colorA do
        lmap[PixelN^.R].AddPixel(PixelN^.G,PixelN^.B,r,g,b);


//   :

//        lmap[PixelP^.R].Fill(0,0,0);
//        lmap[PixelN^.R].Fill(0,0,0);

(*
        lmap[PixelP^.R].SetPixel(PixelP^.G,PixelP^.B,round(255*zx),round(155*zx),round(155*zx));
        lmap[PixelN^.R].SetPixel(PixelN^.G,PixelN^.B,round(155*zx),round(255*zx),round(155*zx));
*)
//        lmap[PixelP^.R].SetPixel(PixelP^.G,PixelP^.B,round(255*zx),round(255*zx),round(255*zx));
//        lmap[PixelN^.R].SetPixel(PixelN^.G,PixelN^.B,round(255*zx),round(255*zx),round(255*zx));


       end;
    end;



//    0  130
fix:=130;
lol:=lol+1;


//      -   
if (lol div 30 = lol/30) then
  for i:=0 to leveldim-1 do
   begin
//map[i].Stir;
//   lmap[i].Blur(1);
   end;

if rpx then
if lol>fix then
 begin

  for i:=0 to leveldim-1 do
   lmap[i].Clamp;

 (*
  for i:=0 to leveldim-1 do
   lmap[i].Blur(1);
   *)
 lol:=0;
//rpx:=false;
 end;


  inc(iterate); //    ( )
end;


end.
